package jugs.javafx.b_properties;

import java.util.ArrayList;
import java.util.List;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise3_Step1_FilterListExample_JDK8 extends Application
{
    @Override
    public void start(final Stage primaryStage)
    {
        final String[] names = { "Kai", "Micha", "Andi", "Andy", "Tom", "Matze", "Mike", "Florian" };
        final ObservableList<String> entries = FXCollections.observableArrayList(names);

        final ListView<String> listView = new ListView<>(entries);
        listView.setPrefHeight(200);

        final TextField searchFor = new TextField();
        searchFor.setPromptText("Enter filter"); // neues cooles feature in JavaFX
        searchFor.textProperty().addListener((observable, oldValue, newValue) -> {
            // Kopie notwendig, da removeIf() in der Collection löscht (Seiteneffekt)
            final List<String> filteredEntries = new ArrayList<>(entries);

            filteredEntries.removeIf(entry -> !entry.toUpperCase().contains(newValue.toUpperCase()));

            listView.setItems(FXCollections.observableArrayList(filteredEntries));
        });

        final VBox vBox = new VBox();
        vBox.setPadding(new Insets(5, 5, 5, 5));
        vBox.setSpacing(10);
        vBox.getChildren().addAll(searchFor, listView);

        primaryStage.setScene(new Scene(vBox, 300, 250));
        primaryStage.setTitle(this.getClass().getSimpleName());
        primaryStage.show();
    }

    public static void main(String[] args)
    {
        launch(args);
    }
}