package jugs.javafx.d_charts;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.LineChart;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.XYChart;
import javafx.stage.Stage;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise1_LineChartExample extends Application
{
    @Override
    public void start(Stage stage)
    {
        final CategoryAxis xAxis = new CategoryAxis();
        xAxis.setLabel("Month");
        final NumberAxis yAxis = new NumberAxis();

        final LineChart<String, Number> lineChart = new LineChart<>(xAxis, yAxis);

        lineChart.setTitle("Books sold per month");

        final XYChart.Series<String, Number> series2013 = createSeriesFor2013();
        final XYChart.Series<String, Number> series2014 = createSeriesFor2014();

        lineChart.getData().add(series2013);
        lineChart.getData().add(series2014);

        stage.setScene(new Scene(lineChart, 800, 600));
        stage.setTitle("Line Chart Sample");
        stage.show();
    }

    protected XYChart.Series<String, Number> createSeriesFor2013()
    {
        final XYChart.Series<String, Number> series = new XYChart.Series<>();
        series.setName("2013");

        series.getData().add(new XYChart.Data<String, Number>("Jan", 173));
        series.getData().add(new XYChart.Data<String, Number>("Feb", 141));
        series.getData().add(new XYChart.Data<String, Number>("Mar", 124));
        series.getData().add(new XYChart.Data<String, Number>("Apr", 224));
        series.getData().add(new XYChart.Data<String, Number>("May", 143));
        series.getData().add(new XYChart.Data<String, Number>("Jun", 136));
        series.getData().add(new XYChart.Data<String, Number>("Jul", 122));
        series.getData().add(new XYChart.Data<String, Number>("Aug", 157));
        series.getData().add(new XYChart.Data<String, Number>("Sep", 243));
        series.getData().add(new XYChart.Data<String, Number>("Oct", 180));
        series.getData().add(new XYChart.Data<String, Number>("Nov", 120));
        series.getData().add(new XYChart.Data<String, Number>("Dec", 130));
        
        return series;
    }
    
    protected XYChart.Series<String, Number> createSeriesFor2014()
    {
        final XYChart.Series<String, Number> series = new XYChart.Series<>();
        series.setName("2014");

        series.getData().add(new XYChart.Data<String, Number>("Jan", 223));
        series.getData().add(new XYChart.Data<String, Number>("Feb", 214));
        series.getData().add(new XYChart.Data<String, Number>("Mar", 175));
        series.getData().add(new XYChart.Data<String, Number>("Apr", 124));
        series.getData().add(new XYChart.Data<String, Number>("May", 234));
        series.getData().add(new XYChart.Data<String, Number>("Jun", 155));
        series.getData().add(new XYChart.Data<String, Number>("Jul", 222));
        series.getData().add(new XYChart.Data<String, Number>("Aug", 145));
        series.getData().add(new XYChart.Data<String, Number>("Sep", 153));
        series.getData().add(new XYChart.Data<String, Number>("Oct", 170));
        series.getData().add(new XYChart.Data<String, Number>("Nov", 192));
        series.getData().add(new XYChart.Data<String, Number>("Dec", 150));
        
        return series;
    }

    public static void main(String[] args)
    {
        launch(args);
    }
}