package jugs.javafx.e_update40;

import java.util.Optional;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.ButtonType;
import javafx.scene.control.Label;
import javafx.stage.Stage;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise1_DialogsJDK8Example extends Application
{
    @Override
    public void start(final Stage primaryStage)
    {
        primaryStage.setOnCloseRequest(event -> 
        {
            final Optional<ButtonType> result = new Alert(Alert.AlertType.CONFIRMATION, "Wollen Sie wirklich das Programm beenden?").showAndWait();
            if (result.isPresent() && result.get().equals(ButtonType.CANCEL))
            {
                System.out.println(result);
                event.consume();
            }
        });

        final Scene scene = new Scene(new Label("Please close me!"), 300, 250);

        primaryStage.setTitle("DialogsJDK8Example");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    public static void main(String[] args)
    {
        launch(args);
    }
}